#include "basic_type_info_decorator.hpp"
#include "type_info_decorator.hpp"
#include "basic_type_decorator.hpp"

namespace boost
{
namespace detail
{
namespace dll
{
basic_type_info_decorator::basic_type_info_decorator()
{
}

basic_type_info_decorator::~basic_type_info_decorator()
{
}

std::string basic_type_info_decorator::decorate(decorating_context &context,
												const extended_type_info &info) const
{
	switch(info.type())
	{
	case extended_type_info::signed_char_type:
		return basic_type_decorator<signed char>().decorate(context);

	case extended_type_info::unsigned_char_type:
		return basic_type_decorator<unsigned char>().decorate(context);

	case extended_type_info::signed_short_type:
		return basic_type_decorator<signed short>().decorate(context);

	case extended_type_info::unsigned_short_type:
		return basic_type_decorator<unsigned short>().decorate(context);

	case extended_type_info::signed_int_type:
		return basic_type_decorator<signed int>().decorate(context);

	case extended_type_info::unsigned_int_type:
		return basic_type_decorator<unsigned int>().decorate(context);

	case extended_type_info::signed_long_type:
		return basic_type_decorator<signed long>().decorate(context);

	case extended_type_info::unsigned_long_type:
		return basic_type_decorator<unsigned long>().decorate(context);

	case extended_type_info::pointer_type:
		return "PA" + type_info_decorator().decorate(context, info.base_type());
	
	case extended_type_info::reference_type:
		return "AA" + type_info_decorator().decorate(context, info.base_type());

	default:
		BOOST_ASSERT(0);
		return "";
	}
}

}; // end namespace dll
}; // end namespace detail
}; // end namespace boost