/*
	class_type_decorator.hpp

	decorates a class type
*/
#ifndef BOOST_DLL_CLASS_TYPE_DECORATOR_HPP
#define BOOST_DLL_CLASS_TYPE_DECORATOR_HPP

#include "decorating_context.hpp"
#include "extended_type_info.hpp"
#include "class_type_info_decorator.hpp"
#include <string>

namespace boost
{
	namespace detail
	{
		namespace dll
		{
			template<typename T>
			class type_decorator;

			template<class T>
			class class_type_decorator
			{
			public:
				class_type_decorator()
				{
				}

				std::string decorate(decorating_context &context) const
				{
					extended_type_info info(type_id<T>());
					return class_type_info_decorator().decorate(context, info);
				}

			private:
				std::string	decorated_class_type_;
				std::string decorated_namespace_part_;
				std::string decorated_class_name_;
				std::string decorated_template_part_;
			};

		}; // end namespace dll
	}; // end namespace detail
}; // end namespace boost

#endif // BOOST_DLL_CLASS_TYPE_DECORATOR_HPP