/*
	class_type_info_decorator.hpp
*/
#ifndef BOOST_DLL_CLASS_TYPE_INFO_DECORATOR_HPP
#define BOOST_DLL_CLASS_TYPE_INFO_DECORATOR_HPP

#include "decorating_context.hpp"
#include "extended_type_info.hpp"
#include <string>

namespace boost
{
	namespace detail
	{
		namespace dll
		{
			class class_type_info_decorator
			{
			public:
				class_type_info_decorator();
				~class_type_info_decorator();

				std::string decorate(decorating_context &context,
									 const extended_type_info &info) const;

			private:
				std::string decorate_class_type(decorating_context &context,
												const extended_type_info &info) const;
				std::string decorate_namespaces(decorating_context &context,
											   const extended_type_info &info) const;
				std::string decorate_template_arguments(decorating_context &context,
														const extended_type_info &info) const;
			};
		}; // end namespace dll
	}; // end namespace detail
}; // end namespace boost

#endif // BOOST_DLL_CLASS_TYPE_INFO_DECORATOR_HPP