#include "decorating_context.hpp"
#include <limits>

const size_t boost::detail::dll::decorating_context::npos = std::numeric_limits<size_t>::max();

boost::detail::dll::decorating_context::decorating_context()
{
}

void boost::detail::dll::decorating_context::push_back(const extended_type_info &i,
													   const std::string &decorated)
{
	//
	// HACK: need to store string of the type_info since type_info is
	//		 not copy constructible
	items_.push_back(std::pair<std::string, std::string>(i.name(), decorated));
}

size_t boost::detail::dll::decorating_context::position(const extended_type_info &info) const
{
	for(std::vector< std::pair<std::string, std::string> >::const_iterator i = items_.begin(); i != items_.end(); ++i)
	{
		if((*i).first == info.name())
			return i - items_.begin();
	}

	return npos;
}