/*
	decorating_context.hpp
*/
#ifndef BOOST_DLL_DECORATING_CONTEXT_HPP
#define BOOST_DLL_DECORATING_CONTEXT_HPP

#include "extended_type_info.hpp"
#include <map> // for std::pair
#include <string>
#include <vector>

namespace boost
{
	namespace detail
	{
		namespace dll
		{
			class decorating_context
			{
			public:
				static const size_t npos;

				decorating_context();
				
				template<typename T>
				void push_back(const std::string &decorated)
				{
					return push_back(type_id<T>(), decorated);
				}

				void push_back(const extended_type_info &i, const std::string &decorated);

				template<typename T>
				size_t position() const
				{
					return position(type_id<T>());
				}

				size_t position(const extended_type_info &i) const;

			private:
				std::vector< std::pair<std::string, std::string> > items_;
			};

		}; // end namespace dll
	}; // end namespace detail
}; // end namespace boost

#endif // BOOST_DLL_DECORATING_CONTEXT_HPP