/*
	dll_macros.hpp
*/
#ifndef BOOST_DLL_MACROS_HPP
#define BOOST_DLL_MACROS_HPP

// 
// FIXME: only include preprocessor functions needed 
#include <boost/preprocessor.hpp>

/*
	note:
		all these macros are very hacky but they come handy to create all
		the neccessary classes and stuff
		maybe there is a much simpler way to do that
*/

//
// this defines the maximum number of parameters
#define BOOST_DLL_MAX_PARAMETERS 10

#define BOOST_DLL_DECL_TEMPLATE_PARAM(Z, N, TEXT) BOOST_PP_COMMA_IF(N) TEXT##N
#define BOOST_DLL_TEMPLATE_LIST(N) BOOST_PP_REPEAT(N, BOOST_DLL_DECL_TEMPLATE_PARAM, typename T)

#define BOOST_DLL_DECL_PARAM(Z, N, TEXT) BOOST_PP_COMMA_IF(N) TEXT##N t##N
#define BOOST_DLL_PARAMS_LIST(N) BOOST_PP_REPEAT(N, BOOST_DLL_DECL_PARAM, typename T)

#define BOOST_DLL_DECL_ARG(Z, N, TEXT) BOOST_PP_COMMA_IF(N) TEXT##N
#define BOOST_DLL_ARG_LIST(N) BOOST_PP_REPEAT(N, BOOST_DLL_DECL_ARG, t)

#define BOOST_DLL_DECLARE_HELPER(Z, N, TEXT) TEXT##(N)
#define BOOST_DLL_DECLARE_CALLS BOOST_PP_REPEAT(BOOST_DLL_MAX_PARAMETERS, BOOST_DLL_DECLARE_HELPER, BOOST_DLL_DECLARE_CALL)
#define BOOST_DLL_DECLARE_FUNCTION_DECORATORS BOOST_PP_REPEAT(BOOST_DLL_MAX_PARAMETERS, BOOST_DLL_DECLARE_HELPER, BOOST_DLL_DECLARE_FUNCTION_DECORATOR)
#define BOOST_DLL_DECLARE_FUNCTION_DESCRIPTORS BOOST_PP_REPEAT(BOOST_DLL_MAX_PARAMETERS, BOOST_DLL_DECLARE_HELPER, BOOST_DLL_DECLARE_FUNCTION_DESCRIPTOR)

#define BOOST_DLL_DECLARE_CALL(NUM_ARGS) \
	template<typename Ret BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_TEMPLATE_LIST(NUM_ARGS) > \
	Ret call(const std::string &functionName BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_PARAMS_LIST(NUM_ARGS)) \
	{ \
		if(!handle_) \
			throw invalid_dll(); \
		detail::dll::function_descriptor##NUM_ARGS<Ret BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_TEMPLATE_LIST(NUM_ARGS)> descriptor(functionName); \
		std::cout << "symbol: " << descriptor.decorate() << std::endl; \
		void *raw = handle_.lookup(descriptor.decorate()); \
		if(!raw) \
			throw unknown_function(); \
		detail::dll::function_descriptor##NUM_ARGS<Ret BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_TEMPLATE_LIST(NUM_ARGS)>::function_type fn_ptr = static_cast<detail::dll::function_descriptor##NUM_ARGS<Ret BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_TEMPLATE_LIST(NUM_ARGS)>::function_type>(raw); \
		return (*fn_ptr)(BOOST_DLL_ARG_LIST(NUM_ARGS)); \
	};

#define BOOST_DLL_DECORATE_ARG(Z, N, TEXT) ret += TEXT##<T##N>().decorate(context);

/*
	FIXME:
		- we need to decorate function names e.g. for template functions 
		- currently only cdecl supported (which is implied)
*/

#define BOOST_DLL_DECLARE_FUNCTION_DECORATOR(NUM_ARGS) \
	template<typename Ret BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_TEMPLATE_LIST(NUM_ARGS)> class function_decorator##NUM_ARGS  \
{ \
public: \
		std::string decorate(const std::string &function_name) const \
		{ \
			decorating_context context; \
			std::string ret = "?"; \
			ret += function_name + \
				   "@@YA" + \
				   type_decorator<Ret>().decorate(context); \
			BOOST_PP_IF(NUM_ARGS, BOOST_PP_REPEAT(NUM_ARGS, BOOST_DLL_DECORATE_ARG, type_decorator), ret += 'X';)\
			ret += BOOST_PP_IF(NUM_ARGS, "@", ""); \
			ret += 'Z'; \
			return ret; \
		} \
};

#define BOOST_DLL_DECLARE_FUNCTION_DESCRIPTOR(NUM_ARGS) \
	template<typename Ret BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_TEMPLATE_LIST(NUM_ARGS)> class function_descriptor##NUM_ARGS : public function_descriptor_base \
{ \
public: \
	typedef Ret (*function_type)(BOOST_DLL_PARAMS_LIST(NUM_ARGS)); \
    \
	function_descriptor##NUM_ARGS(const std::string &function_name) : function_descriptor_base(function_name) {}; \
	std::string decorate() const { return function_decorator##NUM_ARGS<Ret BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_TEMPLATE_LIST(NUM_ARGS)>().decorate(function_name()); } \
};

/*#define BOOST_DLL_DECORATE_TYPE(N, Z, TEXT) <T##N>().decorate(); if(is_class< base_type<T##N> >::value) context.push_back(base_type<T##N>::type, s); ret += s;

#define BOOST_DLL_DECLARE_FUNCTION_DECORATOR(NUM_ARGS) \
template<typename Ret BOOST_PP_COMMA_IF(NUM_ARGS) BOOST_DLL_TEMPLATE_LIST(NUM_ARGS)> class function_decorator \
{ \ 
public: \
	std::string decorate() \
	{ \
		decorating_context context; \
		std::string s, ret; \
		s = type_decorator<Ret>().decorate(); \
		if(is_class< base_type<Ret>::type >::value) \
			context.push_back(base_type<Ret>, s); \
		ret += s; \
		BOOST_PP_REPEAT(NUM_ARGS, BOOST_DLL_DECORATE_TYPE, s = type_decorator); \
		return ret; \
	} \
};*/

#endif // BOOST_DLL_MACROS_HPP