/*
	function_descriptor.hpp
*/
#ifndef BOOST_DLL_FUNCTION_DESCRIPTOR_HPP
#define BOOST_DLL_FUNCTION_DESCRIPTOR_HPP

#include "dll_macros.hpp"
#include <string>

namespace boost
{
	namespace detail
	{
		namespace dll
		{
			class function_descriptor_base
			{
			public:
				typedef void function_type;

				function_descriptor_base(const std::string &function_name)
					: function_name_(function_name) {}

				const std::string &function_name() const { return function_name_; }

				//std::string decorate() const;

			private:
				std::string function_name_;
			};

			BOOST_DLL_DECLARE_FUNCTION_DESCRIPTORS;
			BOOST_DLL_DECLARE_FUNCTION_DECORATORS;
			

		}; // end namespace dll
	}; // end namespace detail
}; // end namespace boost

#endif // BOOST_DLL_FUNCTION_DESCRIPTOR_HPP