#include "dll.hpp"
#include "type_decorator.hpp"
#include "extended_type_info.hpp"
#include <iostream>

class test_class
{
public:
	test_class(int) {}

	typedef std::string (test_class::* fn_ptr)(unsigned char &);

	test_class *test(unsigned char &) {}
	
	void test2(fn_ptr *);
};

namespace std
{
template<typename T, typename Traits = std::char_traits<T> >
class template_test_class
{
};
};


namespace test_ns
{
	struct test {};
	int bla;
}

int main()
{
	boost::dll dll;
	if(!dll.open("TestDLL.dll"))
	{
		std::cerr << "unable to open dll" << std::endl;
		return 1;
	}

	/*try
	{
		boost::detail::dll::extended_type_info info(typeid(int ****));
		boost::detail::dll::extended_type_info const *ptr = &info;
		while(ptr)
		{
			std::cout << ptr->name() << ":" << std::endl;
			std::cout << "-> " << ptr->type_name() << ": " << ptr->type() << std::endl;
			if(ptr->type() & (boost::detail::dll::extended_type_info::pointer_type |
							  boost::detail::dll::extended_type_info::reference_type))
				ptr = &ptr->base_type();
			else
				ptr = 0;
		}
	}
	catch(std::runtime_error &err)
	{
		std::cerr << "failed: " << err.what() << std::endl;
	}

	
	//std::cout << typeid(test_ns::test2).name() << std::endl;
	std::cout << typeid(test_class::test2).name() << std::endl;
	std::cout << typeid(std::string).name() << std::endl;

	boost::detail::dll::decorating_context context;
	std::cout << context.position<std::string>() << std::endl;
	std::cout << boost::detail::dll::type_decorator<std::string>().decorate(context) << std::endl;
	std::cout << context.position<std::string>() << std::endl;*/

	//basic_string<char, struct char_traits<char>, allocator<char>>

	std::cout << boost::detail::dll::type_id<std::string>().name() << std::endl;

	char x = 'a';
	try
	{
		test_class c(5);
		std::template_test_class<char> bla;
		dll.call<void, std::template_test_class<char> >("template_class_test_plain", bla);
	}
	catch(std::runtime_error &err)
	{
		std::cerr << err.what() << std::endl;
	}

	try
	{
		x = dll.call<char, char *>("test4", "yeah");
		std::cout << "test4 returned " << x << " (should be Y)" << std::endl;

		dll.call<void, char &>("test3", x);
		std::cout << "x is " << x << " (should be Y)" << std::endl;

		//dll.call<void, const std::string &>("test3", "std::string test");
	}
	catch(std::runtime_error &err)
	{
		std::cerr << ">> error: " << err.what() << std::endl;
		return 1;
	}
	return 0;
}