/*
	type_decorator.hpp

	class for decorating a type
*/
#ifndef BOOST_DLL_TYPE_DECORATOR_HPP
#define BOOST_DLL_TYPE_DECORATOR_HPP

#include "class_type_decorator.hpp"
#include "basic_type_decorator.hpp"
#include <string>
#include <boost/mpl/if.hpp>
#include <boost/type_traits.hpp>

namespace boost
{
	namespace detail
	{
		namespace dll
		{
			template<typename T>
			class type_decorator
			{
				template<typename T>
				class decorator
					: public mpl::if_<is_class<T>,
									  class_type_decorator<T>,
									  basic_type_decorator<T>
									  >::type
				{
				};

			public:
				type_decorator() {}
				~type_decorator() {}

				std::string decorate(decorating_context &context) const { return decorator_.decorate(context); }

			private:
				decorator<T> decorator_;
			};

		}; // end namespace dll
	}; // end namespace detail
}; // end namespace boost

#endif // BOOST_DLL_TYPE_DECORATOR_HPP