#include "type_info_decorator.hpp"

namespace boost
{
namespace detail
{
namespace dll
{
type_info_decorator::type_info_decorator()
{
}

type_info_decorator::~type_info_decorator()
{
}

std::string type_info_decorator::decorate(decorating_context &context,
										  const extended_type_info &info) const
{
	if(info.type() & extended_type_info::builtin_type_mask)
	{
		return basic_type_info_decorator().decorate(context, info);
	}
	else if(info.type() & (extended_type_info::class_type | extended_type_info::struct_type))
	{
		// 
		// first try to look if the type is already declared, if so reference that
		// definition otherwise create a new definition which can later be referenced
		size_t pos = context.position(info);
		std::string ret;
		if(pos != decorating_context::npos)
		{
			char buf[20];
			_snprintf(buf, sizeof(buf), "@%lu", pos);
			ret = buf;
		}
		else
		{
			ret = class_type_info_decorator().decorate(context, info);
			context.push_back(info, ret);
		}
		
		return ret;
	}
	else
	{
		BOOST_ASSERT(0);
		return "";
	}
}
}; // end namespace dll
}; // end namespace detail
}; // end namespace boost