/*
	type_info_decorator.hpp

	decorates a type info
*/
#ifndef BOOST_DLL_TYPE_INFO_DECORATOR_HPP
#define BOOST_DLL_TYPE_INFO_DECORATOR_HPP

#include "decorating_context.hpp"
#include "extended_type_info.hpp"
#include "basic_type_info_decorator.hpp"
#include "class_type_info_decorator.hpp"
#include <string>

namespace boost
{
	namespace detail
	{
		namespace dll
		{
			class type_info_decorator
			{
			public:
				type_info_decorator();
				~type_info_decorator();

				std::string decorate(decorating_context &context,
									 const extended_type_info &info) const;
			};
		}; // end namespace dll
	}; // end namespace detail
}; // end namespace boost

#endif // BOOST_DLL_TYPE_INFO_DECORATOR_HPP