#include "test.h"
#include <iostream>

void test1()
{
	std::cout << "test1" << std::endl;
}

void test2(char x)
{
	std::cout << "test2(" << x << ")" << std::endl;
}

void test3(char &x)
{
	std::cout << "test3(" << x << ")" << std::endl;
	x = 'Y';
}

char test4(char *str)
{
	std::cout << "test4(" << str << ")" << std::endl;
	return 'Y'; // like Yeah! ;-)
}

void test5(const std::string &str)
{
	std::cout << "test5(" << str << ")" << std::endl;
}

void test6(const std::string &str1, const std::string &str2)
{
	std::cout << "test6(" << str1 << ", " << str2 << ")" << std::endl;
}

void test7(test_class a, test_class *b)
{
}

void class_test_plain(test_class t)
{
	std::cout << "class_test_plain(...)" << std::endl;
}

void class_test_plain2(test_class t1, test_class t2)
{
	std::cout << "class_test_plain2(...)" << std::endl;
}

void class_test_ptr(test_class *t)
{
	std::cout << "class_test_ptr(...)" << std::endl;
}

void class_test_cptr(const test_class *t)
{
	std::cout << "class_test_cptr(...)" << std::endl;
}

void class_test_ref(test_class &t)
{
	std::cout << "class_test_ref(...)" << std::endl;
}

void class_test_cref(const test_class &t)
{
	std::cout << "class_test_cref(...)" << std::endl;
}

void class_test_mixed(test_class t1, test_class *t2)
{
	std::cout << "class_test_mixed(...)" << std::endl;
}

test_class template_class_test_plain(test_class c, std::template_test_class<char> t)
{
	std::cout << "template_class_test_plain(...)" << std::endl;
	return c;
}

void ns_class_test_plain(test_namespace::test_class t)
{
	std::cout << "ns_class_test_plain(...)" << std::endl;
}
